/**
 * Autogenerated by Thrift
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 */
package com.evernote.edam.type;

import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.EnumMap;
import java.util.Set;
import java.util.HashSet;
import java.util.EnumSet;
import java.util.Collections;
import com.evernote.edam.util.BitSet;
import java.util.Arrays;

import org.apache.thrift.*;
import org.apache.thrift.meta_data.*;
import org.apache.thrift.protocol.*;

/**
 * A unique container for a set of notes.
 * <dl>
 * <dt>guid</dt>
 *   <dd>The unique identifier of this notebook.
 *   <br/>
 *   Length:  EDAM_GUID_LEN_MIN - EDAM_GUID_LEN_MAX
 *   <br/>
 *   Regex:  EDAM_GUID_REGEX
 *   </dd>
 * 
 * <dt>name</dt>
 *   <dd>A sequence of characters representing the name of the
 *   notebook.  May be changed by clients, but the account may not contain two
 *   notebooks with names that are equal via a case-insensitive comparison.
 *   Can't begin or end with a space.
 *   <br/>
 *   Length:  EDAM_NOTEBOOK_NAME_LEN_MIN - EDAM_NOTEBOOK_NAME_LEN_MAX
 *   <br/>
 *   Regex:  EDAM_NOTEBOOK_NAME_REGEX
 *   </dd>
 * 
 * <dt>updateSequenceNum</dt>
 *   <dd>A number identifying the last transaction to
 *   modify the state of this object.  The USN values are sequential within an
 *   account, and can be used to compare the order of modifications within the
 *   service.
 *   </dd>
 * 
 * <dt>defaultNotebook</dt>
 *   <dd>If true, this notebook should be used for new notes
 *   whenever the user has not (or cannot) specify a desired target notebook.
 *   For example, if a note is submitted via SMTP email.
 *   The service will maintain at most one defaultNotebook per account.
 *   If a second notebook is created or updated with defaultNotebook set to
 *   true, the service will automatically update the prior notebook's
 *   defaultNotebook field to false.  If the default notebook is deleted
 *   (i.e. "active" set to false), the "defaultNotebook" field will be
 *   set to false by the service.  If the account has no default notebook
 *   set, the service will use the most recent notebook as the default.
 *   </dd>
 * 
 * <dt>serviceCreated</dt>
 *   <dd>The time when this notebook was created on the
 *   service. This will be set on the service during creation, and the service
 *   will provide this value when it returns a Notebook to a client.
 *   The service will ignore this value if it is sent by clients.
 *   </dd>
 * 
 * <dt>serviceUpdated</dt>
 *   <dd>The time when this notebook was last modified on the
 *   service.  This will be set on the service during creation, and the service
 *   will provide this value when it returns a Notebook to a client.
 *   The service will ignore this value if it is sent by clients.
 *   </dd>
 * 
 * <dt>publishing</dt>
 *   <dd>If the Notebook has been opened for public access (i.e.
 *   if 'published' is set to true), then this will point to the set of
 *   publishing information for the Notebook (URI, description, etc.).  A
 *   Notebook cannot be published without providing this information, but it
 *   will persist for later use if publishing is ever disabled on the Notebook.
 *   Clients that do not wish to change the publishing behavior of a Notebook
 *   should not set this value when calling NoteStore.updateNotebook().
 *   </dd>
 * 
 * <dt>published</dt>
 *   <dd>If this is set to true, then the Notebook will be
 *   accessible to the public via the 'publishing' specification, which must
 *   also be set.  If this is set to false, the Notebook will not be available
 *   to the public.
 *   Clients that do not wish to change the publishing behavior of a Notebook
 *   should not set this value when calling NoteStore.updateNotebook().
 *   </dd>
 * </dl>
 */
public class Notebook implements TBase<Notebook._Fields>, java.io.Serializable, Cloneable, Comparable<Notebook> {
  private static final TStruct STRUCT_DESC = new TStruct("Notebook");

  private static final TField GUID_FIELD_DESC = new TField("guid", TType.STRING, (short)1);
  private static final TField NAME_FIELD_DESC = new TField("name", TType.STRING, (short)2);
  private static final TField UPDATE_SEQUENCE_NUM_FIELD_DESC = new TField("updateSequenceNum", TType.I32, (short)5);
  private static final TField DEFAULT_NOTEBOOK_FIELD_DESC = new TField("defaultNotebook", TType.BOOL, (short)6);
  private static final TField SERVICE_CREATED_FIELD_DESC = new TField("serviceCreated", TType.I64, (short)7);
  private static final TField SERVICE_UPDATED_FIELD_DESC = new TField("serviceUpdated", TType.I64, (short)8);
  private static final TField PUBLISHING_FIELD_DESC = new TField("publishing", TType.STRUCT, (short)10);
  private static final TField PUBLISHED_FIELD_DESC = new TField("published", TType.BOOL, (short)11);

  private String guid;
  private String name;
  private int updateSequenceNum;
  private boolean defaultNotebook;
  private long serviceCreated;
  private long serviceUpdated;
  private Publishing publishing;
  private boolean published;

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements TFieldIdEnum {
    GUID((short)1, "guid"),
    NAME((short)2, "name"),
    UPDATE_SEQUENCE_NUM((short)5, "updateSequenceNum"),
    DEFAULT_NOTEBOOK((short)6, "defaultNotebook"),
    SERVICE_CREATED((short)7, "serviceCreated"),
    SERVICE_UPDATED((short)8, "serviceUpdated"),
    PUBLISHING((short)10, "publishing"),
    PUBLISHED((short)11, "published");

    private static final Map<Integer, _Fields> byId = new HashMap<Integer, _Fields>();
    private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

    static {
      for (_Fields field : EnumSet.allOf(_Fields.class)) {
        byId.put((int)field._thriftId, field);
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    public static _Fields findByThriftId(int fieldId) {
      return byId.get(fieldId);
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    public static _Fields findByName(String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final String _fieldName;

    _Fields(short thriftId, String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final int __UPDATESEQUENCENUM_ISSET_ID = 0;
  private static final int __DEFAULTNOTEBOOK_ISSET_ID = 1;
  private static final int __SERVICECREATED_ISSET_ID = 2;
  private static final int __SERVICEUPDATED_ISSET_ID = 3;
  private static final int __PUBLISHED_ISSET_ID = 4;
  private BitSet __isset_bit_vector = new BitSet(5);

  public static final Map<_Fields, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new EnumMap<_Fields, FieldMetaData>(_Fields.class) {{
    put(_Fields.GUID, new FieldMetaData("guid", TFieldRequirementType.OPTIONAL, 
        new FieldValueMetaData(TType.STRING)));
    put(_Fields.NAME, new FieldMetaData("name", TFieldRequirementType.OPTIONAL, 
        new FieldValueMetaData(TType.STRING)));
    put(_Fields.UPDATE_SEQUENCE_NUM, new FieldMetaData("updateSequenceNum", TFieldRequirementType.OPTIONAL, 
        new FieldValueMetaData(TType.I32)));
    put(_Fields.DEFAULT_NOTEBOOK, new FieldMetaData("defaultNotebook", TFieldRequirementType.OPTIONAL, 
        new FieldValueMetaData(TType.BOOL)));
    put(_Fields.SERVICE_CREATED, new FieldMetaData("serviceCreated", TFieldRequirementType.OPTIONAL, 
        new FieldValueMetaData(TType.I64)));
    put(_Fields.SERVICE_UPDATED, new FieldMetaData("serviceUpdated", TFieldRequirementType.OPTIONAL, 
        new FieldValueMetaData(TType.I64)));
    put(_Fields.PUBLISHING, new FieldMetaData("publishing", TFieldRequirementType.OPTIONAL, 
        new StructMetaData(TType.STRUCT, Publishing.class)));
    put(_Fields.PUBLISHED, new FieldMetaData("published", TFieldRequirementType.OPTIONAL, 
        new FieldValueMetaData(TType.BOOL)));
  }});

  static {
    FieldMetaData.addStructMetaDataMap(Notebook.class, metaDataMap);
  }

  public Notebook() {
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public Notebook(Notebook other) {
    __isset_bit_vector.clear();
    __isset_bit_vector.or(other.__isset_bit_vector);
    if (other.isSetGuid()) {
      this.guid = other.guid;
    }
    if (other.isSetName()) {
      this.name = other.name;
    }
    this.updateSequenceNum = other.updateSequenceNum;
    this.defaultNotebook = other.defaultNotebook;
    this.serviceCreated = other.serviceCreated;
    this.serviceUpdated = other.serviceUpdated;
    if (other.isSetPublishing()) {
      this.publishing = new Publishing(other.publishing);
    }
    this.published = other.published;
  }

  public Notebook deepCopy() {
    return new Notebook(this);
  }

  @Deprecated
  public Notebook clone() {
    return new Notebook(this);
  }

  public String getGuid() {
    return this.guid;
  }

  public void setGuid(String guid) {
    this.guid = guid;
  }

  public void unsetGuid() {
    this.guid = null;
  }

  /** Returns true if field guid is set (has been asigned a value) and false otherwise */
  public boolean isSetGuid() {
    return this.guid != null;
  }

  public void setGuidIsSet(boolean value) {
    if (!value) {
      this.guid = null;
    }
  }

  public String getName() {
    return this.name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public void unsetName() {
    this.name = null;
  }

  /** Returns true if field name is set (has been asigned a value) and false otherwise */
  public boolean isSetName() {
    return this.name != null;
  }

  public void setNameIsSet(boolean value) {
    if (!value) {
      this.name = null;
    }
  }

  public int getUpdateSequenceNum() {
    return this.updateSequenceNum;
  }

  public void setUpdateSequenceNum(int updateSequenceNum) {
    this.updateSequenceNum = updateSequenceNum;
    setUpdateSequenceNumIsSet(true);
  }

  public void unsetUpdateSequenceNum() {
    __isset_bit_vector.clear(__UPDATESEQUENCENUM_ISSET_ID);
  }

  /** Returns true if field updateSequenceNum is set (has been asigned a value) and false otherwise */
  public boolean isSetUpdateSequenceNum() {
    return __isset_bit_vector.get(__UPDATESEQUENCENUM_ISSET_ID);
  }

  public void setUpdateSequenceNumIsSet(boolean value) {
    __isset_bit_vector.set(__UPDATESEQUENCENUM_ISSET_ID, value);
  }

  public boolean isDefaultNotebook() {
    return this.defaultNotebook;
  }

  public void setDefaultNotebook(boolean defaultNotebook) {
    this.defaultNotebook = defaultNotebook;
    setDefaultNotebookIsSet(true);
  }

  public void unsetDefaultNotebook() {
    __isset_bit_vector.clear(__DEFAULTNOTEBOOK_ISSET_ID);
  }

  /** Returns true if field defaultNotebook is set (has been asigned a value) and false otherwise */
  public boolean isSetDefaultNotebook() {
    return __isset_bit_vector.get(__DEFAULTNOTEBOOK_ISSET_ID);
  }

  public void setDefaultNotebookIsSet(boolean value) {
    __isset_bit_vector.set(__DEFAULTNOTEBOOK_ISSET_ID, value);
  }

  public long getServiceCreated() {
    return this.serviceCreated;
  }

  public void setServiceCreated(long serviceCreated) {
    this.serviceCreated = serviceCreated;
    setServiceCreatedIsSet(true);
  }

  public void unsetServiceCreated() {
    __isset_bit_vector.clear(__SERVICECREATED_ISSET_ID);
  }

  /** Returns true if field serviceCreated is set (has been asigned a value) and false otherwise */
  public boolean isSetServiceCreated() {
    return __isset_bit_vector.get(__SERVICECREATED_ISSET_ID);
  }

  public void setServiceCreatedIsSet(boolean value) {
    __isset_bit_vector.set(__SERVICECREATED_ISSET_ID, value);
  }

  public long getServiceUpdated() {
    return this.serviceUpdated;
  }

  public void setServiceUpdated(long serviceUpdated) {
    this.serviceUpdated = serviceUpdated;
    setServiceUpdatedIsSet(true);
  }

  public void unsetServiceUpdated() {
    __isset_bit_vector.clear(__SERVICEUPDATED_ISSET_ID);
  }

  /** Returns true if field serviceUpdated is set (has been asigned a value) and false otherwise */
  public boolean isSetServiceUpdated() {
    return __isset_bit_vector.get(__SERVICEUPDATED_ISSET_ID);
  }

  public void setServiceUpdatedIsSet(boolean value) {
    __isset_bit_vector.set(__SERVICEUPDATED_ISSET_ID, value);
  }

  public Publishing getPublishing() {
    return this.publishing;
  }

  public void setPublishing(Publishing publishing) {
    this.publishing = publishing;
  }

  public void unsetPublishing() {
    this.publishing = null;
  }

  /** Returns true if field publishing is set (has been asigned a value) and false otherwise */
  public boolean isSetPublishing() {
    return this.publishing != null;
  }

  public void setPublishingIsSet(boolean value) {
    if (!value) {
      this.publishing = null;
    }
  }

  public boolean isPublished() {
    return this.published;
  }

  public void setPublished(boolean published) {
    this.published = published;
    setPublishedIsSet(true);
  }

  public void unsetPublished() {
    __isset_bit_vector.clear(__PUBLISHED_ISSET_ID);
  }

  /** Returns true if field published is set (has been asigned a value) and false otherwise */
  public boolean isSetPublished() {
    return __isset_bit_vector.get(__PUBLISHED_ISSET_ID);
  }

  public void setPublishedIsSet(boolean value) {
    __isset_bit_vector.set(__PUBLISHED_ISSET_ID, value);
  }

  public void setFieldValue(_Fields field, Object value) {
    switch (field) {
    case GUID:
      if (value == null) {
        unsetGuid();
      } else {
        setGuid((String)value);
      }
      break;

    case NAME:
      if (value == null) {
        unsetName();
      } else {
        setName((String)value);
      }
      break;

    case UPDATE_SEQUENCE_NUM:
      if (value == null) {
        unsetUpdateSequenceNum();
      } else {
        setUpdateSequenceNum((Integer)value);
      }
      break;

    case DEFAULT_NOTEBOOK:
      if (value == null) {
        unsetDefaultNotebook();
      } else {
        setDefaultNotebook((Boolean)value);
      }
      break;

    case SERVICE_CREATED:
      if (value == null) {
        unsetServiceCreated();
      } else {
        setServiceCreated((Long)value);
      }
      break;

    case SERVICE_UPDATED:
      if (value == null) {
        unsetServiceUpdated();
      } else {
        setServiceUpdated((Long)value);
      }
      break;

    case PUBLISHING:
      if (value == null) {
        unsetPublishing();
      } else {
        setPublishing((Publishing)value);
      }
      break;

    case PUBLISHED:
      if (value == null) {
        unsetPublished();
      } else {
        setPublished((Boolean)value);
      }
      break;

    }
  }

  public void setFieldValue(int fieldID, Object value) {
    setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
  }

  public Object getFieldValue(_Fields field) {
    switch (field) {
    case GUID:
      return getGuid();

    case NAME:
      return getName();

    case UPDATE_SEQUENCE_NUM:
      return new Integer(getUpdateSequenceNum());

    case DEFAULT_NOTEBOOK:
      return new Boolean(isDefaultNotebook());

    case SERVICE_CREATED:
      return new Long(getServiceCreated());

    case SERVICE_UPDATED:
      return new Long(getServiceUpdated());

    case PUBLISHING:
      return getPublishing();

    case PUBLISHED:
      return new Boolean(isPublished());

    }
    throw new IllegalStateException();
  }

  public Object getFieldValue(int fieldId) {
    return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
  }

  /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    switch (field) {
    case GUID:
      return isSetGuid();
    case NAME:
      return isSetName();
    case UPDATE_SEQUENCE_NUM:
      return isSetUpdateSequenceNum();
    case DEFAULT_NOTEBOOK:
      return isSetDefaultNotebook();
    case SERVICE_CREATED:
      return isSetServiceCreated();
    case SERVICE_UPDATED:
      return isSetServiceUpdated();
    case PUBLISHING:
      return isSetPublishing();
    case PUBLISHED:
      return isSetPublished();
    }
    throw new IllegalStateException();
  }

  public boolean isSet(int fieldID) {
    return isSet(_Fields.findByThriftIdOrThrow(fieldID));
  }

  public boolean equals(Object that) {
    if (that == null)
      return false;
    if (that instanceof Notebook)
      return this.equals((Notebook)that);
    return false;
  }

  public boolean equals(Notebook that) {
    if (that == null)
      return false;

    boolean this_present_guid = true && this.isSetGuid();
    boolean that_present_guid = true && that.isSetGuid();
    if (this_present_guid || that_present_guid) {
      if (!(this_present_guid && that_present_guid))
        return false;
      if (!this.guid.equals(that.guid))
        return false;
    }

    boolean this_present_name = true && this.isSetName();
    boolean that_present_name = true && that.isSetName();
    if (this_present_name || that_present_name) {
      if (!(this_present_name && that_present_name))
        return false;
      if (!this.name.equals(that.name))
        return false;
    }

    boolean this_present_updateSequenceNum = true && this.isSetUpdateSequenceNum();
    boolean that_present_updateSequenceNum = true && that.isSetUpdateSequenceNum();
    if (this_present_updateSequenceNum || that_present_updateSequenceNum) {
      if (!(this_present_updateSequenceNum && that_present_updateSequenceNum))
        return false;
      if (this.updateSequenceNum != that.updateSequenceNum)
        return false;
    }

    boolean this_present_defaultNotebook = true && this.isSetDefaultNotebook();
    boolean that_present_defaultNotebook = true && that.isSetDefaultNotebook();
    if (this_present_defaultNotebook || that_present_defaultNotebook) {
      if (!(this_present_defaultNotebook && that_present_defaultNotebook))
        return false;
      if (this.defaultNotebook != that.defaultNotebook)
        return false;
    }

    boolean this_present_serviceCreated = true && this.isSetServiceCreated();
    boolean that_present_serviceCreated = true && that.isSetServiceCreated();
    if (this_present_serviceCreated || that_present_serviceCreated) {
      if (!(this_present_serviceCreated && that_present_serviceCreated))
        return false;
      if (this.serviceCreated != that.serviceCreated)
        return false;
    }

    boolean this_present_serviceUpdated = true && this.isSetServiceUpdated();
    boolean that_present_serviceUpdated = true && that.isSetServiceUpdated();
    if (this_present_serviceUpdated || that_present_serviceUpdated) {
      if (!(this_present_serviceUpdated && that_present_serviceUpdated))
        return false;
      if (this.serviceUpdated != that.serviceUpdated)
        return false;
    }

    boolean this_present_publishing = true && this.isSetPublishing();
    boolean that_present_publishing = true && that.isSetPublishing();
    if (this_present_publishing || that_present_publishing) {
      if (!(this_present_publishing && that_present_publishing))
        return false;
      if (!this.publishing.equals(that.publishing))
        return false;
    }

    boolean this_present_published = true && this.isSetPublished();
    boolean that_present_published = true && that.isSetPublished();
    if (this_present_published || that_present_published) {
      if (!(this_present_published && that_present_published))
        return false;
      if (this.published != that.published)
        return false;
    }

    return true;
  }

  public int hashCode() {
    return 0;
  }

  public int compareTo(Notebook other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;
    Notebook typedOther = (Notebook)other;

    lastComparison = Boolean.valueOf(isSetGuid()).compareTo(isSetGuid());
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = TBaseHelper.compareTo(guid, typedOther.guid);
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = Boolean.valueOf(isSetName()).compareTo(isSetName());
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = TBaseHelper.compareTo(name, typedOther.name);
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = Boolean.valueOf(isSetUpdateSequenceNum()).compareTo(isSetUpdateSequenceNum());
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = TBaseHelper.compareTo(updateSequenceNum, typedOther.updateSequenceNum);
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = Boolean.valueOf(isSetDefaultNotebook()).compareTo(isSetDefaultNotebook());
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = TBaseHelper.compareTo(defaultNotebook, typedOther.defaultNotebook);
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = Boolean.valueOf(isSetServiceCreated()).compareTo(isSetServiceCreated());
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = TBaseHelper.compareTo(serviceCreated, typedOther.serviceCreated);
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = Boolean.valueOf(isSetServiceUpdated()).compareTo(isSetServiceUpdated());
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = TBaseHelper.compareTo(serviceUpdated, typedOther.serviceUpdated);
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = Boolean.valueOf(isSetPublishing()).compareTo(isSetPublishing());
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = TBaseHelper.compareTo(publishing, typedOther.publishing);
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = Boolean.valueOf(isSetPublished()).compareTo(isSetPublished());
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = TBaseHelper.compareTo(published, typedOther.published);
    if (lastComparison != 0) {
      return lastComparison;
    }
    return 0;
  }

  public void read(TProtocol iprot) throws TException {
    TField field;
    iprot.readStructBegin();
    while (true)
    {
      field = iprot.readFieldBegin();
      if (field.type == TType.STOP) { 
        break;
      }
      _Fields fieldId = _Fields.findByThriftId(field.id);
      if (fieldId == null) {
        TProtocolUtil.skip(iprot, field.type);
      } else {
        switch (fieldId) {
          case GUID:
            if (field.type == TType.STRING) {
              this.guid = iprot.readString();
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case NAME:
            if (field.type == TType.STRING) {
              this.name = iprot.readString();
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case UPDATE_SEQUENCE_NUM:
            if (field.type == TType.I32) {
              this.updateSequenceNum = iprot.readI32();
              setUpdateSequenceNumIsSet(true);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case DEFAULT_NOTEBOOK:
            if (field.type == TType.BOOL) {
              this.defaultNotebook = iprot.readBool();
              setDefaultNotebookIsSet(true);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case SERVICE_CREATED:
            if (field.type == TType.I64) {
              this.serviceCreated = iprot.readI64();
              setServiceCreatedIsSet(true);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case SERVICE_UPDATED:
            if (field.type == TType.I64) {
              this.serviceUpdated = iprot.readI64();
              setServiceUpdatedIsSet(true);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case PUBLISHING:
            if (field.type == TType.STRUCT) {
              this.publishing = new Publishing();
              this.publishing.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case PUBLISHED:
            if (field.type == TType.BOOL) {
              this.published = iprot.readBool();
              setPublishedIsSet(true);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
        }
        iprot.readFieldEnd();
      }
    }
    iprot.readStructEnd();
    validate();
  }

  public void write(TProtocol oprot) throws TException {
    validate();

    oprot.writeStructBegin(STRUCT_DESC);
    if (this.guid != null) {
      if (isSetGuid()) {
        oprot.writeFieldBegin(GUID_FIELD_DESC);
        oprot.writeString(this.guid);
        oprot.writeFieldEnd();
      }
    }
    if (this.name != null) {
      if (isSetName()) {
        oprot.writeFieldBegin(NAME_FIELD_DESC);
        oprot.writeString(this.name);
        oprot.writeFieldEnd();
      }
    }
    if (isSetUpdateSequenceNum()) {
      oprot.writeFieldBegin(UPDATE_SEQUENCE_NUM_FIELD_DESC);
      oprot.writeI32(this.updateSequenceNum);
      oprot.writeFieldEnd();
    }
    if (isSetDefaultNotebook()) {
      oprot.writeFieldBegin(DEFAULT_NOTEBOOK_FIELD_DESC);
      oprot.writeBool(this.defaultNotebook);
      oprot.writeFieldEnd();
    }
    if (isSetServiceCreated()) {
      oprot.writeFieldBegin(SERVICE_CREATED_FIELD_DESC);
      oprot.writeI64(this.serviceCreated);
      oprot.writeFieldEnd();
    }
    if (isSetServiceUpdated()) {
      oprot.writeFieldBegin(SERVICE_UPDATED_FIELD_DESC);
      oprot.writeI64(this.serviceUpdated);
      oprot.writeFieldEnd();
    }
    if (this.publishing != null) {
      if (isSetPublishing()) {
        oprot.writeFieldBegin(PUBLISHING_FIELD_DESC);
        this.publishing.write(oprot);
        oprot.writeFieldEnd();
      }
    }
    if (isSetPublished()) {
      oprot.writeFieldBegin(PUBLISHED_FIELD_DESC);
      oprot.writeBool(this.published);
      oprot.writeFieldEnd();
    }
    oprot.writeFieldStop();
    oprot.writeStructEnd();
  }

  public String toString() {
    StringBuilder sb = new StringBuilder("Notebook(");
    boolean first = true;

    if (isSetGuid()) {
      sb.append("guid:");
      if (this.guid == null) {
        sb.append("null");
      } else {
        sb.append(this.guid);
      }
      first = false;
    }
    if (isSetName()) {
      if (!first) sb.append(", ");
      sb.append("name:");
      if (this.name == null) {
        sb.append("null");
      } else {
        sb.append(this.name);
      }
      first = false;
    }
    if (isSetUpdateSequenceNum()) {
      if (!first) sb.append(", ");
      sb.append("updateSequenceNum:");
      sb.append(this.updateSequenceNum);
      first = false;
    }
    if (isSetDefaultNotebook()) {
      if (!first) sb.append(", ");
      sb.append("defaultNotebook:");
      sb.append(this.defaultNotebook);
      first = false;
    }
    if (isSetServiceCreated()) {
      if (!first) sb.append(", ");
      sb.append("serviceCreated:");
      sb.append(this.serviceCreated);
      first = false;
    }
    if (isSetServiceUpdated()) {
      if (!first) sb.append(", ");
      sb.append("serviceUpdated:");
      sb.append(this.serviceUpdated);
      first = false;
    }
    if (isSetPublishing()) {
      if (!first) sb.append(", ");
      sb.append("publishing:");
      if (this.publishing == null) {
        sb.append("null");
      } else {
        sb.append(this.publishing);
      }
      first = false;
    }
    if (isSetPublished()) {
      if (!first) sb.append(", ");
      sb.append("published:");
      sb.append(this.published);
      first = false;
    }
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws TException {
    // check for required fields
  }

}

